package no.ntnu.idi.bacchus;

import no.ntnu.idi.bacchus.domain.MealDescription;
import tlcpc.utility.GlueCode;

import org.hibernate.SessionFactory;
import org.hibernate.cfg.Configuration;
import org.hibernate.tool.hbm2ddl.SchemaExport;


public class HibernateUtil {

	private static final SessionFactory sessionFactory = buildSessionFactory();

	private static SessionFactory buildSessionFactory() {
		
		try{
			//Create SessionFactory from hibernate.cfg.xml
			return new Configuration().configure().buildSessionFactory();
		}
		catch(Throwable ex){
			//Make sure you log the exception, as it might be swallowed
			ex.printStackTrace();
			System.err.println("Initial SessionFactory creation failed. "+ex);
			throw new ExceptionInInitializerError(ex);
		}
	}
	
	public static SessionFactory getSessionFactory(){
		return sessionFactory;
	}
	
	public static void createDbSchema() {

		Configuration cfg = new Configuration().configure();
		SchemaExport sch = new SchemaExport(cfg);
		
		sch.setDelimiter(";");
		sch.setOutputFile("meal_table.ddl"); //Generated script is written to this file
	    sch.create(true, true); //Print sript to console, export script to database.   
	}
	
	public static void generateHibernateMapping(Class mappedClass) {
		GlueCode.hibernate_map_file(mappedClass);
	}
}
