package no.ntnu.idi.bacchus;

import java.util.List;
import no.ntnu.idi.bacchus.domain.MealDescription;
import no.ntnu.idi.bacchus.domain.MealSolution;

import org.hibernate.Session;
import org.hibernate.SessionFactory;

public class MealManager {

	
	
	public static void main(String[] args) {
		boolean store = false; //Store or not
		
		MealManager mealManager = new MealManager();
		HibernateUtil.generateHibernateMapping(MealDescription.class);
		//HibernateUtil.createDbSchema(); //Brukes bare ved oppstart av ny DB
		if(store){
			int mealId = mealManager.getLastMealId()+1;
			mealManager.createAndStoreMeal(mealId, "Laks");
		}
		else{
			List meals = mealManager.getListOfMeals();
			System.out.println("\nListing Meals: ");
			if(meals.size() == 0)
				System.out.println("NO MEALS FOUND.");
			for(int i = 0 ; i < meals.size() ; i++){
				MealSolution theMeal = (MealSolution)meals.get(i);
				System.out.println("Meal: "+theMeal.getMealId()+" Title: "+theMeal.getRecipeTitle());
			}
			System.out.println();
		}
		HibernateUtil.getSessionFactory().close();
	}
	
	public List getListOfMeals() {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		List result = session.createQuery("from MealSolution").list(); 
		session.getTransaction().commit();
		return result;
	}
	
	private int getLastMealId(){
		int lastMealId = 0;
		List meals = getListOfMeals();
		if(meals.size() > 0){
			MealDescription lastMeal = (MealDescription)meals.get(meals.size()-1);
			lastMealId = lastMeal.getMealId();
		}
		return lastMealId;
	}

	public void createAndStoreMeal(int mealId, String title) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		
		MealSolution theMeal = new MealSolution();
		//theMeal.setMealId(mealId); 
		//theMeal.setRecipeTitle(title);
		session.save(theMeal);
		
		session.getTransaction().commit();
	}
	
	
	/**public void createAndStoreMeals(int[] mealId, String[] titles){
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		session.beginTransaction();
		
		for(int i = 0; i < titles.length; i++){
			MealDescription theMeal = new MealDescription();
			theMeal.setMealId(mealId[i]); 
			theMeal.setRecipeTitle(titles[i]);
			session.save(theMeal);
		}
		session.getTransaction().commit();
	}**/
}