CREATE schema bacchus;

/* Drop tables before creation */
DROP table mealGrapes;	
DROP table mealAccessories;
DROP table grapeTypes;
DROP table accessoriesTypes;
DROP table meal;

/* Creating tables */
CREATE table meal(mealId INT NOT NULL GENERATED BY DEFAULT AS IDENTITY, 
	PRIMARY KEY(mealId), 
	recipeTitle VARCHAR(100), 
	norwegianTitle VARCHAR(100), 
	foodType VARCHAR(20), 
	sauceType VARCHAR(20), 
	wineOrigin VARCHAR(20), 
	wineTitle VARCHAR(100));

CREATE table grapeTypes(grapeId INT NOT NULL GENERATED BY DEFAULT AS IDENTITY, 
	PRIMARY KEY(grapeId), 
	grapeName VARCHAR(20));

CREATE table accessoriesTypes(accessoriesId INT NOT NULL GENERATED BY DEFAULT AS IDENTITY, 
	PRIMARY KEY(accessoriesId), 
	accessoriesName VARCHAR(20));

CREATE table mealGrapes(mealId INT, grapeId INT,
	FOREIGN KEY (mealId) REFERENCES meal(mealId), 
	FOREIGN KEY (grapeId) REFERENCES grapeTypes(grapeId));

CREATE table mealAccessories(mealId INT, accessoriesId INT, 
	FOREIGN KEY (mealId) REFERENCES meal(mealId), 
	FOREIGN KEY (accessoriesId) REFERENCES accessoriesTypes(accessoriesId));

/* Insert statements*/
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Bacalo from Lofoten','Bacalao fra Lofoten','Clipfish', 'TomatoSauce', 'Portugal','Niepoort Fabelaktig Douro 2005');			--1
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Pork fillet whirled in bacon','Baconsnurr','PorkTenderloin', 'NoSauce','Italy','Vignabaldo Rosso di Torgiano 1998');	--2
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Beef sirloin on a vegetablesragout with red wine sauce and rice','Biff av ytrefilet paa groennsaksragout med roedvinssaus og ris','BeefSirloin', 'RedWineSauce','Spain','Marqus de Condordia Tempranillo 2007');	--3
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Coq au wine','Coq au vin','Cock', 'GravySauce','Portugal','Vidigal Reserva 2005');	--4
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Steamed cod on a bed of lentils with vegetables','Dampet torsk paa linseseng med groennsaker','Cod', 'NoSauce','France','Ola Signature 2008');	--5
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Elk steak','Elgsteik med sjysaus, jordskokkpur, aspargesboenner, ristet sopp og slottspotete','Elk', 'GravySauce','Australia','Wolf Blass Yellow Label Cabernet Sauvignon 2003/2004');	--6
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Pheasantbreast with olive-gravy','Fasanbryst med olivensjy','Pheasant', 'GravySauce','Italy','Zaccagnini Montepulciano d''Abruzzo 2005');	--7
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Stuffed reindeer steak','Fylt reinsdyrstek','Reindeer', 'RedWineSauce','France','Bourgogne Couvent des Jacobins 2004');	--8
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Stuffed tenderloin','Fylt svinefilet','PorkTenderloin', 'RedWineSauce','Italy','Terre di Prenzano Chianti Classico 2006');	--9
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Norwegian lamb stew','Faarikaal','Mutton', 'NoSauce','France','Domaine Robert Vic Cuve Slection 2008');	--10
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Turkey','Helstekt kalkun','WholeTurkey', 'GravySauce','France','Torriglione Barbera d''Alba 2004/2005');	--11	
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle)
	values('Lamb cutlets with thyme and garlic potato pure','Lammekoteletter med timian- og hvitl&Oslashkspotetpur','LambCutlets', 'RedWineSauce','France','Amirault La Coudraye 2007');	--12	
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Grilled catfish with red wine sauce','Grillet steinbit med rdvinssaus','Catfish', 'RedWineSauce','France','Bouchard la Vigne Pinot Noir 2005');	--13
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Lamb cutlets with champignons and feta cheese','Lammekoteletter med champignon og fetaost','LambCutlets', 'NoSauce','France','Canepa Estate Cabernet Sauvignon 2005');	--14
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Lamb fricassee','Lammefrikass','LambStew', 'GravySauce','Italy','Baron Ricasoli Formulae 2008');	--15
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Herb burgers','Urteburgere','Vegetarian', 'NoSauce','Italy','Grifo Chianti 2004');	--16
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Reindeer fillet','Reinsdyrfilet','Reindeer', 'GameSauce','France','Vidal-Fleury Crozes-Hermitage 2006');	--17
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Grouse breast','Rosastekt rypebryst','Grouse', 'GameSauce','France','Gaillard Cte-Rtie 2002');	--18
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Red wine braised pheasant leg','Rdvinsbraisert fasanlr','Pheasant', 'RedWineSauce','France','Crozes-Hermitage Silne');	--19
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Lamb stew with dill','Lammegryte med dill og skogens gull','LambStew', 'CreamSauce', 'Spain', 'Montecillo Crianza 2005');	--20
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Hare fillet with pepper sauce','Harefilet med peppersaus og kremet selleri og fennikel','Hare', 'GameSauce','Spain','Condado de Haza Crianza 2006');	--21
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Italian fried coalfish','Seibiff p italiensk','Coalfish', 'NoSauce','NewZealand','Antinori Santa Cristina 2005');	--22
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Lamb saute with mushrooms','Lammesaut med kantareller','LambStew', 'ProvenceSauce','Spain','Tamaral Roble 2008');	--23
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Grilled chicken-legs','Grillede kyllinglr','ChickenFillet', 'NoSauce','California','Ravenswood Zen of Zin 2004');	--24
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Turkey steak with sweet potatoes, ruccola- and cheese-butter','Kalkunbiff med stpotet, ruccula- og ostesmr','TurkeySteak', 'NoSauce','Italy','Zenato Valpolicella Classico Superiore 2007');	--25
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Turkey fillet on a bed of vegetables','Kalkunfilet p partyseng','TurkeyFillet', 'RedWineSauce','Italy','Zenato Valpolicella Classico Superiore 2007');	--26
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Pork rib','Juleribbe','PorkRib', 'GravySauce','Italy','Zenato Valpolicella Classico Superiore 2007');	--27
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Lamb roast','Klassisk lammestek','LambRoast', 'RedWineSauce','France','Domaine d''Andzon 2007');	--28
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Mouton  la Bourguignonne','Mouton  la Bourguignonne','LambStew', 'RedWineSauce','France','Arne Brimis Viltvin 2007');	--29
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Gamepan','Viltpanne','Reindeer', 'NoSauce','Fance','La Roche 2004');			--30
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Chicken fillet with Parma ham and Parmesan cheese','Kyllingfilet med parmaskinke,parmesan og salvie','ChickenFillet', 'NoSauce','Italy','I Sodi del Paretaio Chianti 2008');	--31
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Baked calf fillet','Helstekt kalvefilet, bakt tomat og sellerirot, lime-potetpur, calvadossaus med ste rosiner','Calf', 'RedWineSauce','Italy','Villa Antinori 2005');	--32

INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Anglerfish with mushroom','Breiflabb med stekt sopp og rdvinsmr','Anglerfish', 'RedWineSauce','Italy','Villa Cafaggio Chianti Classico 2005'); --33
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Aubergine pan','Auberginepanne','Vegetarian', 'GravySauce','Italy','Col di Sasso Sangiovese & Cabernet Sauvignon 2005');  --34
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Bacon beef','Baconbiff med choronsaus og hasselbackpoteter','BeefSirloin', 'BearnaiseSauce','Australia','Brown Brothers Cabernet Sauvignon 2003/2004');  --35
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Baked coalfish','Ovnsbakt sei med tomat, paprika og roedloek','Coalfish', 'NoSauce','Italy','Duca del Frassino Valpolicella Superiore 2007');  --36
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Beef and creamed onion','Biff i snre med kremet lk','BeefSirloin', 'CreamSauce','California','Beringer Founders'' Estate Zinfandel 2004'); --37

INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Beef and tagliatelle','Biff og tagliatelle','BeefSirloin', 'CreamSauce','Italy','Masi Modello delle Venezie Rosso 2008');  --38
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Beef Pebre','Beef Pebre','BeefTenderloin', 'NoSauce','Argentina','Elsa Malbec 2005'); --39
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Beef with aroma butter and potato salad','Biff med aromasmr og potetsalat','BeefSirloin', 'NoSauce','France','Ch. Franc Cardinal 2002'); --40
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Beef with asparges, mushrooms and potato puree','Biff med asparges, sterssopp og mandelpotetpur','BeefTenderloin', 'CreamSauce','France','Domaine de l''Ameillaud Cairanne 2006'); --41
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Cheese table','Ostebord','CheeseDish', 'NoSauce','Argentina','Argento Malbec 2008/2009'); --42
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Chilicannelloni','Chilicannelloni','VegetarianDish', 'TomatoSauce','Portugal','Vidigal Reserva 2005'); --43
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Deer filled with mozzarella','Mozzarellafylt hjorte-tournedos','Deer', 'RedWineSauce', 'Italy', 'Fonterutoli Chianti Classico 2007'); --44
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Deer fillet with risotto, chestnutpuree and mushroom','Hjortefilet med risotto, kastanjepur og sopp','Deer', 'MushroomSauce','France','Saint Cosme Les Deux Albion 2001');  --45
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Elk stew','Lapskaus med elgkjtt','Elk', 'GravySauce','Italy','Isole e Olena Chianti Classico 2004'); --46
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Exotic pork fillet','Eksotisk svinefilet','PorkSirloin', 'NoSauce','Italy','La Trincherina Barbera d''Asti 2007'); --47
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Grilled clipfish','Grillet klippfisk med tomatsaus','Clipfish', 'TomatoSauce','Portugal','Flor de Crasto 2007'); --48
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Jarlsberg suffl','Jarlsberg-ostesuffl','CheeseDish', 'NoSauce','France','Pellerin Ctes du Roussillon Villages 2002'); --49
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Lens burgers','Linseburgere','VegetarianDish', 'NoSauce','France','Vignoble du Sud Syrah 2005'); --50
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Loin of pork with vegetables','Estragonspekket svinekam med spennende groennsaker','PorkSirloin', 'GravySauce','Spain','Campo Viejo Reserva 2001');  --51
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Mexican bean stew','Meksikansk boennegryte','Vegetarian', 'NoSauce','Italy','Sergo Alighieri Possessioni Rosso 2007'); --52
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Pasta Carbonara','Pasta Carbonara','Bacon', 'CreamSauce','Spain','Cune Crianza 2005'); --53
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Reindeer stew with cheese sauce','Finnbiff med ostesaus','Reindeer', 'CreamSauce','Australia','Lindemans Cawarra Shiraz Cabernet 2007'); 	--54
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Roedeer fillet','Raadyrfilet i parmaskinke med skogsopp og pastabagel og troeffelsaus','Roedeer', 'GravySauce','Chile','Carmen Cabernet Sauvignon 2004'); --55 
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Soft cheeses','Myke oster','CheeseDish', 'NoSauce','Spain','Marques de la Concordia Reserva 2005'); --56
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Steamed spring cod','Dampet skrei med fennikelpur og rdvinsaus','Cod', 'RedWineSauce','France','Guigal Ctes du Rhne 2005'); 	--57
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('Stewed beef','Bankebiff','BeefSirloin', 'GravySauce','Spain','Gran Coronas Reserva 2005'); --58	
INSERT into meal(recipeTitle, norwegianTitle, foodType, sauceType, wineOrigin, wineTitle) 
	values('The morning after','Dagen derp','Bacon', 'NoSauce','SouthAfrica','Two Oceans Shiraz 2008'); --59


INSERT into grapeTypes(grapeName) values('Barbera'); 			--1
INSERT into grapeTypes(grapeName) values('CabernetFranc');		--2
INSERT into grapeTypes(grapeName) values('CabernetSauvignon');	--3
INSERT into grapeTypes(grapeName) values('Grenache');			--4
INSERT into grapeTypes(grapeName) values('Malbec');				--5
INSERT into grapeTypes(grapeName) values('Merlot');				--6
INSERT into grapeTypes(grapeName) values('PinotNoir');			--7
INSERT into grapeTypes(grapeName) values('Sangiovese');			--8
INSERT into grapeTypes(grapeName) values('Syrah');				--9
INSERT into grapeTypes(grapeName) values('Zinfandel');			--10
INSERT into grapeTypes(grapeName) values('Tempranillo');		--11 
INSERT into grapeTypes(grapeName) values('Montepulciano');		--12
INSERT into grapeTypes(grapeName) values('Corvina');			--13
INSERT into grapeTypes(grapeName) values('Rondinella');			--14
INSERT into grapeTypes(grapeName) values('Molinara');			--15
INSERT into grapeTypes(grapeName) values('TintaMiuda');			--16
INSERT into grapeTypes(grapeName) values('Camarate');			--17
INSERT into grapeTypes(grapeName) values('Carignan');			--18

INSERT into accessoriesTypes(accessoriesName) values('Bread');					--1
INSERT into accessoriesTypes(accessoriesName) values('Pasta');					--2
INSERT into accessoriesTypes(accessoriesName) values('Potatoes');				--3
INSERT into accessoriesTypes(accessoriesName) values('Rice');					--4
INSERT into accessoriesTypes(accessoriesName) values('Salad');					--5
INSERT into accessoriesTypes(accessoriesName) values('Vegetable');				--6
INSERT into accessoriesTypes(accessoriesName) values('HasselbackPotatoes');		--7
INSERT into accessoriesTypes(accessoriesName) values('MashedPotatoes');			--8
INSERT into accessoriesTypes(accessoriesName) values('BakedPotatoes');			--9
INSERT into accessoriesTypes(accessoriesName) values('BoiledPotatoes');			--10
INSERT into accessoriesTypes(accessoriesName) values('Salt-BakedPotatoes');		--11
INSERT into accessoriesTypes(accessoriesName) values('SweetPotatoes');			--12
INSERT into accessoriesTypes(accessoriesName) values('FrenchFries');			--13
INSERT into accessoriesTypes(accessoriesName) values('Mushroom');				--14
INSERT into accessoriesTypes(accessoriesName) values('Onion');					--15
INSERT into accessoriesTypes(accessoriesName) values('Garlic');					--16
INSERT into accessoriesTypes(accessoriesName) values('Cucumbers');				--17
INSERT into accessoriesTypes(accessoriesName) values('Carrots');				--18
INSERT into accessoriesTypes(accessoriesName) values('Asparges');				--19
INSERT into accessoriesTypes(accessoriesName) values('Tomatoes');				--20
INSERT into accessoriesTypes(accessoriesName) values('Cabbage');				--21
INSERT into accessoriesTypes(accessoriesName) values('Pepper');					--22
INSERT into accessoriesTypes(accessoriesName) values('Peas');					--23
INSERT into accessoriesTypes(accessoriesName) values('PotatoWedges');			--24
INSERT into accessoriesTypes(accessoriesName) values('FriedPotatoSlices');		--25
INSERT into accessoriesTypes(accessoriesName) values('Aubergine');				--26
INSERT into accessoriesTypes(accessoriesName) values('Risotto');				--27
INSERT into accessoriesTypes(accessoriesName) values('Chestnut');				--28


INSERT into mealGrapes values(1,11); 		--Tempranillo
INSERT into mealAccessories values(1,10);	--BoiledPotatoes
INSERT into mealAccessories values(1,1);	--Bread

INSERT into mealGrapes values(2,8);			--Sangiovese
INSERT into mealAccessories values(2,5);	--Salad
INSERT into mealAccessories values(2,1);	--Bread

INSERT into mealGrapes values(3,11);		--Tempranillo
INSERT into mealAccessories values(3,4);	--Rice

INSERT into mealGrapes values(4,11);		--Tempranillo
INSERT into mealGrapes values(4,16);		--TintaMiuda
INSERT into mealAccessories values(4,14);	--Mushroom
INSERT into mealAccessories values(4,10);	--BoiledPotatoes
INSERT into mealAccessories values(4,4);	--Rice
INSERT into mealAccessories values(4,1);	--Bread
INSERT into mealAccessories values(4,6);	--Vegetables

INSERT into mealGrapes values(5,4);			--Grenache
INSERT into mealGrapes values(5,18);		--Carignan
INSERT into mealAccessories values(5,6);	--Vegetables

INSERT into mealGrapes values(6,3); 		--CabernetSauvignon
INSERT into mealAccessories values(6,19); 	--Asparges
INSERT into mealAccessories values(6,14);	--Mushroom
INSERT into mealAccessories values(6,10);	--BoiledPotatoes

INSERT into mealGrapes values(7,12); 		--Montepulciano
INSERT into mealAccessories values(7,6); 	--Vegetables

INSERT into mealGrapes values(8,7); 		--PinotNoir
INSERT into mealAccessories values(8,18); 	--Carrots
INSERT into mealAccessories values(8,6);	--Vegetables
INSERT into mealAccessories values(8,15);	--Onion

INSERT into mealGrapes values(9,8); 		--Sangiovese
INSERT into mealAccessories values(9,6); 	--Vegetables

INSERT into mealGrapes values(10,4);		--Grenache
INSERT into mealGrapes values(10,9);		--Syrah
INSERT into mealGrapes values(10,6);		--Merlot
INSERT into mealAccessories values(10,21);	--Cabbage
INSERT into mealAccessories values(10,10);	--BoiledPotatoes

INSERT into mealGrapes values(11,1);		--Barbera
INSERT into mealAccessories values(11,10);	--BoiledPotatoes
INSERT into mealAccessories values(11,6);	--Vegetables

INSERT into mealGrapes values(12,2);		--CabernetFranc
INSERT into mealAccessories values(12,8);	--MashedPotatoes

INSERT into mealGrapes values(13,7);		--PinotNoir
INSERT into mealAccessories values(13,18);	--Carrots
INSERT into mealAccessories values(13,14);	--Mushroom
INSERT into mealAccessories values(13,15);	--Onion

INSERT into mealGrapes values(14,3);		--CabernetSauvignon
INSERT into mealAccessories values(14,16);	--Garlic
INSERT into mealAccessories values(14,14);	--Mushroom
INSERT into mealAccessories values(14,15);	--Onion

INSERT into mealGrapes values(15,8);		--Sangiovese
INSERT into mealAccessories values(15,10);	--BoiledPotatoes
INSERT into mealAccessories values(15,6);	--Vegetables

INSERT into mealGrapes values(16,8);		--Sangiovese
INSERT into mealAccessories values(16,5);	--Salad

INSERT into mealGrapes values(17,9);		--Sangiovese
INSERT into mealAccessories values(17,14);	--Mushroom
INSERT into mealAccessories values(17,9);	--BakedPotatoes

INSERT into mealGrapes values(18,9);		--Syrah
INSERT into mealAccessories values(18,18);	--Carrots
INSERT into mealAccessories values(18,10);	--BoiledPotatoes
INSERT into mealAccessories values(18,15);	--Onion

INSERT into mealGrapes values(19,9);		--Syrah
INSERT into mealAccessories values(19,14);	--Mushroom
INSERT into mealAccessories values(19,8);	--MashedPotatoes
INSERT into mealAccessories values(19,15);	--Onion

INSERT into mealGrapes values(20,11);		--Tempranillo
INSERT into mealAccessories values(20,10);	--BoiledPotatoes
INSERT into mealAccessories values(20,1);	--Bread

INSERT into mealGrapes values(21,11);		--Tempranillo
INSERT into mealAccessories values(21,6);	--Vegetables

INSERT into mealGrapes values(22,8);		--Sangiovese
INSERT into mealGrapes values(22,6);		--Merlot
INSERT into mealAccessories values(22,10);	--BoiledPotatoes
INSERT into mealAccessories values(22,1);	--Bread
INSERT into mealAccessories values(22,6);	--Vegetables

INSERT into mealGrapes values(23,11);		--Tempranillo
INSERT into mealAccessories values(23,14);	--Mushroom
INSERT into mealAccessories values(23,8);	--MashedPotatoes

INSERT into mealGrapes values(24,10);		--Zinfandel
INSERT into mealAccessories values(24,5);	--Salad

INSERT into mealGrapes values(25,13);		--Corvina
INSERT into mealGrapes values(25,14);		--Rondinella
INSERT into mealGrapes values(25,8);		--Sangiovese
INSERT into mealGrapes values(25,15);		--Molinara
INSERT into mealAccessories values(25,5);	--Salad
INSERT into mealAccessories values(25,12);	--SweetPotatoes

INSERT into mealGrapes values(26,13);		--Corvina
INSERT into mealGrapes values(26,14);		--Rondinella
INSERT into mealGrapes values(26,8);		--Sangiovese
INSERT into mealGrapes values(26,15);		--Molinara
INSERT into mealAccessories values(26,6);	--Vegetables

INSERT into mealGrapes values(27,13);		--Corvina
INSERT into mealGrapes values(27,14);		--Rondinella
INSERT into mealGrapes values(27,8);		--Sangiovese
INSERT into mealGrapes values(27,15);		--Molinara
INSERT into mealAccessories values(27,6);	--Vegetables
INSERT into mealAccessories values(27,10);	--BoiledPotatoes

INSERT into mealGrapes values(28,4);		--Grenache
INSERT into mealGrapes values(28,9);		--Syrah
INSERT into mealAccessories values(28,8);	--MashedPotatoes
INSERT into mealAccessories values(28,6);	--Vegetables

INSERT into mealGrapes values(29,4);		--Grenache
INSERT into mealGrapes values(29,9);		--Syrah
INSERT into mealAccessories values(29,10);	--BoiledPotatoes
INSERT into mealAccessories values(29,4);	--Rice

INSERT into mealGrapes values(30,6);		--Merlot
INSERT into mealGrapes values(30,3);		--CabernetSauvignon
INSERT into mealAccessories values(30,8);	--MashedPotatoes
INSERT into mealAccessories values(30,6);	--Vegetables

INSERT into mealGrapes values(31,8);		--Sangiovese
INSERT into mealGrapes values(31,3);		--CabernetSauvignon
INSERT into mealGrapes values(31,6);		--Merlot
INSERT into mealGrapes values(31,9);		--Syrah
INSERT into mealAccessories values(31,2);	--Pasta

INSERT into mealGrapes values(32,8);		--Sangiovese
INSERT into mealGrapes values(32,3);		--CabernetSauvignon
INSERT into mealGrapes values(32,6);		--Merlot
INSERT into mealGrapes values(32,9);		--Syrah
INSERT into mealAccessories values(32,6);	--Vegetables
INSERT into mealAccessories values(32,8);	--MashedPotatoes

INSERT into mealGrapes values(33,8);		--Sangiovese
INSERT into mealAccessories values(33,14);	--Mushroom

INSERT into mealGrapes values(34,8);		--Sangiovese
INSERT into mealGrapes values(34,3);		--CabernetSauvignon
INSERT into mealAccessories values(34,20);	--Tomatoes
INSERT into mealAccessories values(34,26);	--Aubergine

INSERT into mealGrapes values(35,3);		--CabernetSauvignon
INSERT into mealAccessories values(35,14);	--Mushroom
INSERT into mealAccessories values(35,15);	--Onion
INSERT into mealAccessories values(35,16);	--Garlic

INSERT into mealGrapes values(36,13);		--Corvina
INSERT into mealGrapes values(36,15);		--Molinara
INSERT into mealGrapes values(36,14);		--Rondinella
INSERT into mealAccessories values(36,15);	--Onion
INSERT into mealAccessories values(36,22);	--Pepper
INSERT into mealAccessories values(36,16);	--Garlic
INSERT into mealAccessories values(36,20);	--Tomatoes

INSERT into mealGrapes values(37,10);		--Zinfandel
INSERT into mealAccessories values(37,15);	--Onion
INSERT into mealAccessories values(37,10);	--BoiledPotatoes
INSERT into mealAccessories values(37,18);	--Carrots
INSERT into mealAccessories values(37,6);	--Vegetables

INSERT into mealGrapes values(38,13);		--Corvina
INSERT into mealAccessories values(38,2);	--Pasta
INSERT into mealAccessories values(38,14);	--Mushroom
INSERT into mealAccessories values(38,22);	--Pepper

INSERT into mealGrapes values(39,5);		--Malbec
INSERT into mealAccessories values(39,4);	--Rice
INSERT into mealAccessories values(39,14);	--Pepper

INSERT into mealGrapes values(40,6);		--Merlot
INSERT into mealGrapes values(40,2);		--CabernetFranc
INSERT into mealAccessories values(40,10);	--BoiledPotatoes
INSERT into mealAccessories values(40,5);	--Salad

INSERT into mealGrapes values(41,4);		--Grenache
INSERT into mealGrapes values(41,9);		--Syrah
INSERT into mealGrapes values(41,18);		--Carignan
INSERT into mealAccessories values(41,8);	--MashedPotatoes
INSERT into mealAccessories values(41,14);	--Mushroom
INSERT into mealAccessories values(41,19);	--Asparges

INSERT into mealGrapes values(42,5);		--Malbec
INSERT into mealAccessories values(42,5);	--Salad

INSERT into mealGrapes values(43,11);		--TintaRoriz
INSERT into mealGrapes values(43,16);		--TintaMiuda
INSERT into mealGrapes values(43,5);		--Camerate
INSERT into mealAccessories values(43,5);	--Salad
INSERT into mealAccessories values(43,1);	--Bread

INSERT into mealGrapes values(44,8);		--Sangiovese
INSERT into mealGrapes values(44,6);		--Merlot
INSERT into mealAccessories values(44,10);	--BoiledPotatoes
INSERT into mealAccessories values(44,20);	--Tomatoes

INSERT into mealGrapes values(45,9);		--Syrah
INSERT into mealGrapes values(45,4);		--Grenache
INSERT into mealAccessories values(45,27);	--Risotto
INSERT into mealAccessories values(45,16);	--Garlic
INSERT into mealAccessories values(45,15);	--Onion
INSERT into mealAccessories values(45,28);	--Chestnut

INSERT into mealGrapes values(46,8);		--Sangiovese
INSERT into mealGrapes values(46,9);		--Syrah
INSERT into mealGrapes values(46,3);		--CabernetSauvignon
INSERT into mealAccessories values(46,10);	--BoiledPotatoes
INSERT into mealAccessories values(46,15);	--Onion
INSERT into mealAccessories values(46,18);	--Carrots
INSERT into mealAccessories values(46,6);	--Vegetables

INSERT into mealGrapes values(47,1);		--Barbera
INSERT into mealAccessories values(47,16);	--Garlic
INSERT into mealAccessories values(47,6);	--Vegetables

INSERT into mealGrapes values(48,11);		--Tempranillo
INSERT into mealAccessories values(48,25);	--FriedPotatoSlices
INSERT into mealAccessories values(48,20);	--Tomatoes

INSERT into mealGrapes values(49,4);		--Grenache
INSERT into mealGrapes values(49,9);		--Syrah
INSERT into mealGrapes values(49,18);		--Carignan
INSERT into mealAccessories values(49,1);	--Bread
INSERT into mealAccessories values(49,5);	--Salad

INSERT into mealGrapes values(50,9);		--Syrah
INSERT into mealAccessories values(50,10);	--BoiledPotatoes
INSERT into mealAccessories values(50,6);	--Vegetables

INSERT into mealGrapes values(51,11);		--Tempranillo
INSERT into mealAccessories values(51,10);	--BoiledPotatoes
INSERT into mealAccessories values(51,6);	--Vegetables
INSERT into mealAccessories values(51,22);	--Pepper

INSERT into mealGrapes values(52,13);		--Corvina
INSERT into mealGrapes values(52,14);		--Rondinella
INSERT into mealGrapes values(52,15);		--Molinara
INSERT into mealAccessories values(52,4);	--Rice

INSERT into mealGrapes values(53,11);		--Tempranillo
INSERT into mealAccessories values(53,2);	--Pasta
INSERT into mealAccessories values(53,23);	--Peas

INSERT into mealGrapes values(54,9);		--Syrah
INSERT into mealGrapes values(54,3);		--CabernetSauvignon
INSERT into mealAccessories values(54,10);	--BoiledPotatoes
INSERT into mealAccessories values(54,14);	--Mushroom
INSERT into mealAccessories values(54,6);	--Vegetables

INSERT into mealGrapes values(55,3);		--CabernetSauvignon
INSERT into mealAccessories values(55,2);	--Pasta
INSERT into mealAccessories values(55,14);	--Mushroom

INSERT into mealGrapes values(56,11);		--Tempranillo
INSERT into mealAccessories values(56,6);	--Vegetables

INSERT into mealGrapes values(57,4);		--Grenache
INSERT into mealGrapes values(57,9);		--Syrah
INSERT into mealAccessories values(57,10);	--BoiledPotatoes
INSERT into mealAccessories values(57,20);	--Tomatoes

INSERT into mealGrapes values(58,3);		--CabernetSauvignon
INSERT into mealGrapes values(58,11);		--Tempranillo
INSERT into mealAccessories values(58,10);	--BoiledPotatoes
INSERT into mealAccessories values(58,6);	--Vegetables

INSERT into mealGrapes values(59,9);		--Syrah
INSERT into mealAccessories values(59,1);	--Bread
INSERT into mealAccessories values(59,14);	--Mushroom
INSERT into mealAccessories values(59,5);	--Salad

/*SELECT * FROM bacchus.meal;*/
/*SELECT * FROM bacchus.grapeTypes;*/
/*SELECT * FROM bacchus.accessoriesTypes;*/

/* SELECT meal.recipeTitle, grape.grapeName FROM meal as meal, grapeTypes as grape, mealGrapes as grapes WHERE meal.mealId=grapes.mealId AND grapes.grapeId=grape.grapeId;
SELECT meal.recipeTitle, acc.accessoriesName FROM meal as meal, accessoriesTypes as acc, mealAccessories as accMeal WHERE meal.mealId=accMeal.mealId AND accMeal.accessoriesId=acc.accessoriesId ORDER BY meal.mealId;
*/