package no.ntnu.idi.bacchus.domain;

import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import java.util.Map.Entry;

import jcolibri.cbrcore.Attribute;
import jcolibri.datatypes.Instance;

public class MealDescription implements jcolibri.cbrcore.CaseComponent {

	private int mealId;
	private Instance foodType;
	private String sauceType;
	private Set<Instance> accessoriesType = new HashSet<Instance>();


	public Set<Instance> getAccessoriesType() {
		return accessoriesType;
	}


	public void setAccessoriesType(Set<Instance> accessoriesType) {
		this.accessoriesType = accessoriesType;
	}
	
	public String printAccessories(){
		String accessories = new String();
		accessories = "{";
		Iterator i = accessoriesType.iterator();
		while(i.hasNext()){
			accessories += i.next() +", ";
		}
		accessories = accessories.substring(0, accessories.length()-2) +"}";
		return accessories;
	}
	


	@Override
	public Attribute getIdAttribute() {
		return new Attribute("mealId", this.getClass());
	}


	public int getMealId() {
		return mealId;
	}


	public void setMealId(int caseId) {
		this.mealId = caseId;
	}


	public Instance getFoodType() {
		return foodType;
	}


	public void setFoodType(Instance foodType) {
		this.foodType = foodType;
	}


	public String getSauceType() {
		return sauceType;
	}


	public void setSauceType(String sauceType) {
		this.sauceType = sauceType;
	}



	public String toString(){
		//System.out.println("Grapes: " + printGrapes());
		return "("+mealId+"; "+foodType+"; "+printAccessories()+"; "+sauceType+")";
		//return "("+mealId+";"+recipeTitle+";"+norwegianTitle+";"+foodType+";"+accessoriesType+";"+sauceType+";"+grapeType+";"+wineOrigin+")";
	}
}
