package no.ntnu.idi.bacchus.domain;

import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

import jcolibri.cbrcore.Attribute;
import jcolibri.datatypes.Instance;

public class MealSolution  implements jcolibri.cbrcore.CaseComponent{

	private String mealId;
	private String wineOrigin;
	private String wineTitle;
	private String recipeTitle;
	private String norwegianTitle;
	private Set<GrapeDescription> grapeType = new HashSet<GrapeDescription> ();
	
	
	@Override
	public Attribute getIdAttribute() {
		return new Attribute("mealId", this.getClass());
	}
	
	public String getRecipeTitle() {
		return recipeTitle;
	}


	public void setRecipeTitle(String recipeTitle) {
		this.recipeTitle = recipeTitle;
	}


	public String getNorwegianTitle() {
		return norwegianTitle;
	}


	public void setNorwegianTitle(String norwegianTitle) {
		this.norwegianTitle = norwegianTitle;
	}
	
	public String getMealId() {
		return mealId;
	}

	public void setMealId(String mealId) {
		this.mealId = mealId;
	}

	public String getWineOrigin() {
		return wineOrigin;
	}

	public void setWineOrigin(String wineOrigin) {
		this.wineOrigin = wineOrigin;
	}

	public String getWineTitle() {
		return wineTitle;
	}

	public void setWineTitle(String wineTitle) {
		this.wineTitle = wineTitle;
	}
	
	public Set<GrapeDescription> getGrapeType() {
		return this.grapeType;
	}

	public void setGrapeType(Set<GrapeDescription> grapeType) {
		this.grapeType = grapeType;
	}

	public String printGrapes(){
		String grapes = new String();
		grapes = "{";
		Iterator i = this.getGrapeType().iterator();
		while(i.hasNext()){
			grapes += i.next() + ", ";
		}
		grapes = grapes.substring(0, grapes.length()-2) +"}";
		return grapes;
	}
	
	public String toString(){
		return "("+mealId+"; "+recipeTitle+"; "+wineOrigin+"; "+printGrapes()+"; "+wineTitle+")";
	}

}
